diff -Naur -x .svn stamp-0.9.10/lib/tm.h stamp-0.9.10_Distribute/lib/tm.h
--- stamp-0.9.10/lib/tm.h	2008-09-09 07:42:42.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/tm.h	2014-12-18 12:23:07.252569418 +0900
@@ -69,11 +69,17 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef TM_H
 #define TM_H 1
 
+#ifdef __bgq__
+#include <unistd.h>
+#endif
+/*#define USE_TLH  Moved to each benchmark's Defines.common.mk*/
+
 #ifdef HAVE_CONFIG_H
 # include "STAMP_config.h"
 #endif
@@ -170,8 +176,20 @@
 #  define TM_PRINT2                     printf
 #  define TM_PRINT3                     printf
 
+#ifdef USE_TLH
+#  include "memory.h"
+#  define P_MEMORY_STARTUP(numThread)   do { \
+                                            bool_t status; \
+                                            status = memory_init((numThread), \
+                                                                 ((1<<28) / numThread), \
+                                                                 2); \
+                                            assert(status); \
+                                        } while (0) /* enforce comma */
+#  define P_MEMORY_SHUTDOWN()           memory_destroy()
+#else /* !USE_TLH */
 #  define P_MEMORY_STARTUP(numThread)   /* nothing */
 #  define P_MEMORY_SHUTDOWN()           /* nothing */
+#endif /* !USE_TLH */
 
 #endif /* !SIMULATOR */
 
@@ -325,6 +343,89 @@
 
 #  endif /* !OTM */
 
+#elif defined(HTM_IBM)
+#include "htm_ibm.h"
+
+#  define TM_ARG                        /* nothing */
+#  define TM_ARG_ALONE                  /* nothing */
+#  define TM_ARGDECL                    /* nothing */
+#  define TM_ARGDECL_ALONE              /* nothing */
+#  define TM_CALLABLE                   /* nothing */
+
+#  define TM_STARTUP(numThread)         tm_startup_ibm()
+#  define TM_SHUTDOWN()                 tm_shutdown_ibm()
+
+#  define TM_THREAD_ENTER()             tm_thread_enter_ibm()
+#  define TM_THREAD_EXIT()              tm_thread_exit_ibm()
+
+#ifdef USE_TLH
+#include "thread.h"
+#include "memory.h"
+#    define P_MALLOC(size)              memory_get(thread_getId(), size)
+#    define P_FREE(ptr)                 /* TODO: thread local free is non-trivial */
+#    define TM_MALLOC(size)             memory_get(thread_getId(), size)
+#    define TM_FREE(ptr)                /* TODO: thread local free is non-trivial */
+#else /* !USE_TLH */
+#    define P_MALLOC(size)              malloc(size)
+#    define P_FREE(ptr)                 free(ptr)
+#    define TM_MALLOC(size)             malloc(size)
+#    define TM_FREE(ptr)                free(ptr)
+#endif /* !USE_TLH */
+
+#ifdef __bgq__
+#    define TM_BEGIN()                    _Pragma("tm_atomic")	\
+  {
+#    define TM_BEGIN_ID(id)               TM_BEGIN()
+#    define TM_BEGIN_RO()                 TM_BEGIN()
+#    define TM_END()                      }
+#    define TM_RESTART()                  write(1, "", 0)
+#    define TM_EARLY_RELEASE(var)         /* nothing */
+#else /* ! __bgq__ */
+#    define TM_BEGIN()                    tbegin_ibm(0)
+#    define TM_BEGIN_ID(id)               tbegin_ibm(id)
+#    define TM_BEGIN_RO()                 tbegin_ibm()
+#    define TM_END()                      tend_ibm()
+#    define TM_RESTART()                  tabort_ibm()
+#    define TM_EARLY_RELEASE(var)         /* nothing */
+#endif /* ! __bgq__ */
+
+/* Hardware Lock Elision on Haswell */
+#elif defined(HLE_INTEL)
+#include "hle_intel.h"
+
+#  define TM_ARG                        /* nothing */
+#  define TM_ARG_ALONE                  /* nothing */
+#  define TM_ARGDECL                    /* nothing */
+#  define TM_ARGDECL_ALONE              /* nothing */
+#  define TM_CALLABLE                   /* nothing */
+
+#  define TM_STARTUP(numThread)         tm_startup_hle()
+#  define TM_SHUTDOWN()                 tm_shutdown_hle()
+
+#  define TM_THREAD_ENTER()             tm_thread_enter_hle()
+#  define TM_THREAD_EXIT()              tm_thread_exit_hle()
+
+#ifdef USE_TLH
+#include "thread.h"
+#include "memory.h"
+#    define P_MALLOC(size)              memory_get(thread_getId(), size)
+#    define P_FREE(ptr)                 /* TODO: thread local free is non-trivial */
+#    define TM_MALLOC(size)             memory_get(thread_getId(), size)
+#    define TM_FREE(ptr)                /* TODO: thread local free is non-trivial */
+#else /* !USE_TLH */
+#    define P_MALLOC(size)              malloc(size)
+#    define P_FREE(ptr)                 free(ptr)
+#    define TM_MALLOC(size)             malloc(size)
+#    define TM_FREE(ptr)                free(ptr)
+#endif /* !USE_TLH */
+
+#    define TM_BEGIN()                    tbegin_hle(0)
+#    define TM_BEGIN_ID(id)               tbegin_hle(id)
+#    define TM_BEGIN_RO()                 tbegin_hle()
+#    define TM_END()                      tend_hle()
+#    define TM_RESTART()                  tabort_hle()
+#    define TM_EARLY_RELEASE(var)         /* nothing */
+
 
 /* =============================================================================
  * STM - Software Transactional Memory
@@ -486,19 +587,78 @@
 
 #  else /* !SIMULATOR */
 
+#ifdef USE_TLH
+#include "thread.h"
+#include "memory.h"
+#    define P_MALLOC(size)              memory_get(thread_getId(), size)
+#    define P_FREE(ptr)                 /* TODO: thread local free is non-trivial */
+#    define TM_MALLOC(size)             memory_get(thread_getId(), size)
+#    define TM_FREE(ptr)                /* TODO: thread local free is non-trivial */
+#else /* !USE_TLH */
 #    define P_MALLOC(size)              malloc(size)
 #    define P_FREE(ptr)                 free(ptr)
 #    define TM_MALLOC(size)             malloc(size)
 #    define TM_FREE(ptr)                free(ptr)
+#endif /* !USE_TLH */
 
 #  endif /* !SIMULATOR */
 
+#if defined(GLOBAL_LOCK)
+#include <stdlib.h>
+#include "thread.h"
+
+#ifdef USE_MUTEX
+#  define TM_BEGIN()			     \
+  do {					     \
+    THREAD_MUTEX_LOCK(global_lock);	     \
+  } while (0)
+#  define TM_END()			     \
+  do {					     \
+    THREAD_MUTEX_UNLOCK(global_lock);	     \
+  } while (0)
+#else /* ! USE_MUTEX */
+#include "mfence.h"
+#if defined(__370__)
+#  define TM_BEGIN()						\
+  do {								\
+  cs_t local_value = 0; cs_t new_value = 1;			\
+  while (cs(&local_value, (cs_t *)&global_lock, new_value)) {	\
+    while (local_value = global_lock)				\
+      ;								\
+  }								\
+  } while (0)
+#elif defined(__GNUC__) || defined(__IBMC__)
+#  define TM_BEGIN()						\
+  do {								\
+    while (__sync_val_compare_and_swap(&global_lock, 0, 1)) {	\
+      while (global_lock)					\
+	;							\
+    }								\
+  } while (0)
+#else
+#error
+#endif
+#  define TM_END()			     \
+  do {					     \
+    memory_fence();			     \
+    global_lock = 0;			     \
+  } while (0)
+#endif /* USE_MUTEX */
+#  define TM_BEGIN_ID(id) TM_BEGIN()
+#  define TM_BEGIN_RO() TM_BEGIN()
+#  define TM_RESTART()                  assert(0)
+#  define TM_EARLY_RELEASE(var)         /* nothing */
+
+#else /* !GLOBAL_LOCK */
+
 #  define TM_BEGIN()                    /* nothing */
+#  define TM_BEGIN_ID(id) TM_BEGIN()
 #  define TM_BEGIN_RO()                 /* nothing */
 #  define TM_END()                      /* nothing */
 #  define TM_RESTART()                  assert(0)
 
 #  define TM_EARLY_RELEASE(var)         /* nothing */
+#endif /* GLOBAL_LOCK */
 
 #endif /* SEQUENTIAL */
 
@@ -547,6 +707,74 @@
 
 #else /* !STM */
 
+#ifdef HTM_CONSERVE_RWBUF
+static inline void resume_tx() {
+  asm volatile (".long 0x7c2005dd":::"cr0","memory");
+}
+
+static inline void suspend_tx() {
+  asm volatile (".long 0x7c0005dd":::"cr0","memory");
+}
+
+static inline long resume_read_long(volatile long *varp) {
+  long res;
+  resume_tx();
+  res=*varp;
+  suspend_tx();
+  return res;
+}
+
+static inline void *resume_read_ptr(volatile void **varp) {
+  void *res;
+  resume_tx();
+  res=*varp;
+  suspend_tx();
+  return res;
+}
+
+static inline float resume_read_float(volatile float *varp) {
+  float res;
+  resume_tx();
+  res=*varp;
+  suspend_tx();
+  return res;
+}
+
+static inline long resume_write_long(volatile long *varp, long val) {
+  resume_tx();
+  *varp=val;
+  suspend_tx();
+  return val;
+}
+
+static inline void *resume_write_ptr(volatile void **varp,void *val) {
+  resume_tx();
+  *varp=val;
+  suspend_tx();
+  return val;
+}
+
+static inline float resume_write_float(volatile float *varp,float val) {
+  resume_tx();
+  *varp=val;
+  suspend_tx();
+  return val;
+}
+
+#  define TM_SHARED_READ(var)           (resume_read_long(&(var)))
+#  define TM_SHARED_READ_P(var)         (resume_read_ptr(&(var)))
+#  define TM_SHARED_READ_F(var)         (resume_read_float(&(var)))
+
+#  define TM_SHARED_WRITE(var, val)     (resume_write_long(&(var),val))
+#  define TM_SHARED_WRITE_P(var, val)   (resume_write_ptr(&(var),val))
+#  define TM_SHARED_WRITE_F(var, val)   (resume_write_float(&(var),val))
+
+#  define TM_LOCAL_WRITE(var, val)      ({var = val; var;})
+#  define TM_LOCAL_WRITE_P(var, val)    ({var = val; var;})
+#  define TM_LOCAL_WRITE_F(var, val)    ({var = val; var;})
+
+#else /* HTM_CONSERVE_RWBUF */
+
 #  define TM_SHARED_READ(var)           (var)
 #  define TM_SHARED_READ_P(var)         (var)
 #  define TM_SHARED_READ_F(var)         (var)
@@ -559,6 +787,8 @@
 #  define TM_LOCAL_WRITE_P(var, val)    ({var = val; var;})
 #  define TM_LOCAL_WRITE_F(var, val)    ({var = val; var;})
 
+#endif /* !HTM_CONSERVE_RWBUF */
+
 #endif /* !STM */
 
 
diff -Naur -x .svn stamp-0.9.10/lib/types.h stamp-0.9.10_Distribute/lib/types.h
--- stamp-0.9.10/lib/types.h	2008-09-09 07:42:42.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/types.h	2014-12-18 12:23:12.051569591 +0900
@@ -68,6 +68,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef TYPES_H
@@ -88,6 +89,12 @@
 
 typedef unsigned long ulong_t;
 
+#ifdef FALSE
+#undef FALSE
+#endif
+#ifdef TRUE
+#undef TRUE
+#endif
 enum {
     FALSE = 0,
     TRUE  = 1
diff -Naur -x .svn stamp-0.9.10/lib/utility.h stamp-0.9.10_Distribute/lib/utility.h
--- stamp-0.9.10/lib/utility.h	2008-09-09 07:42:42.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/utility.h	2014-12-18 12:23:17.839755488 +0900
@@ -68,6 +68,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #ifndef UTILITY_H
@@ -101,6 +102,15 @@
         (_a / _b) + (((_a % _b) > 0) ? (1) : (0)); \
     })
 
+#define MAX_nogcc(a,b) \
+  ((a) > (b) ? (a) : (b))
+
+#define MIN_nogcc(a,b) \
+  ((a) < (b) ? (a) : (b))
+
+#define DIVIDE_AND_ROUND_UP_nogcc(a,b) \
+  (((a) / (b)) + ((((a) % (b)) > 0) ? (1) : (0)))
+
 
 #endif /* UTILITY_H */
 
diff -Naur -x .svn stamp-0.9.10/lib/vector.c stamp-0.9.10_Distribute/lib/vector.c
--- stamp-0.9.10/lib/vector.c	2008-09-09 07:42:42.000000000 +0900
+++ stamp-0.9.10_Distribute/lib/vector.c	2014-12-18 12:23:23.562716818 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <stdlib.h>
@@ -86,7 +87,11 @@
 vector_alloc (long initCapacity)
 {
     vector_t* vectorPtr;
+#ifdef __GNUC__
     long capacity = MAX(initCapacity, 1);
+#else
+    long capacity = MAX_nogcc(initCapacity, 1);
+#endif
 
     vectorPtr = (vector_t*)malloc(sizeof(vector_t));
 
@@ -112,7 +117,11 @@
 Pvector_alloc (long initCapacity)
 {
     vector_t* vectorPtr;
+#ifdef __GNUC__
     long capacity = MAX(initCapacity, 1);
+#else
+    long capacity = MAX_nogcc(initCapacity, 1);
+#endif
 
     vectorPtr = (vector_t*)P_MALLOC(sizeof(vector_t));
 
diff -Naur -x .svn stamp-0.9.10/ssca2/computeGraph.c stamp-0.9.10_Distribute/ssca2/computeGraph.c
--- stamp-0.9.10/ssca2/computeGraph.c	2008-09-09 07:42:07.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/computeGraph.c	2014-12-18 12:23:34.013610647 +0900
@@ -62,6 +62,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -180,9 +181,13 @@
         }
     }
 
-    TM_BEGIN();
+    TM_BEGIN_ID(4);
     long tmp_maxNumVertices = (long)TM_SHARED_READ(global_maxNumVertices);
+#ifdef __GNUC__
     long new_maxNumVertices = MAX(tmp_maxNumVertices, maxNumVertices) + 1;
+#else
+    long new_maxNumVertices = MAX_nogcc(tmp_maxNumVertices, maxNumVertices) + 1;
+#endif
     TM_SHARED_WRITE(global_maxNumVertices, new_maxNumVertices);
     TM_END();
 
@@ -296,7 +301,7 @@
 
     thread_barrier_wait();
 
-    TM_BEGIN();
+    TM_BEGIN_ID(5);
     TM_SHARED_WRITE(
         global_outVertexListSize,
         ((long)TM_SHARED_READ(global_outVertexListSize) + outVertexListSize)
@@ -472,7 +477,7 @@
                 }
             }
             if (k == GPtr->outVertexIndex[v]+GPtr->outDegree[v]) {
-                TM_BEGIN();
+	      TM_BEGIN_ID(6);
                 /* Add i to the impliedEdgeList of v */
                 long inDegree = (long)TM_SHARED_READ(GPtr->inDegree[v]);
                 TM_SHARED_WRITE(GPtr->inDegree[v], (inDegree + 1));
diff -Naur -x .svn stamp-0.9.10/ssca2/createPartition.c stamp-0.9.10_Distribute/ssca2/createPartition.c
--- stamp-0.9.10/ssca2/createPartition.c	2008-09-09 07:42:07.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/createPartition.c	2014-12-18 12:23:40.351663954 +0900
@@ -62,6 +62,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 #include "createPartition.h"
 #include "utility.h"
@@ -76,13 +77,22 @@
                  long* startPtr, long* stopPtr)
 {
     long range = max - min;
+#ifdef __GNUC__
     long chunk = MAX(1, ((range + n/2) / n)); /* rounded */
+#else
+    long _tmp = (range + n/2) / n;
+    long chunk = MAX_nogcc(1, _tmp); /* rounded */
+#endif
     long start = min + chunk * id;
     long stop;
     if (id == (n-1)) {
         stop = max;
     } else {
+#ifdef __GNUC__
         stop = MIN(max, (start + chunk));
+#else
+        stop = MIN_nogcc(max, (start + chunk));
+#endif
     }
 
     *startPtr = start;
diff -Naur -x .svn stamp-0.9.10/ssca2/cutClusters.c stamp-0.9.10_Distribute/ssca2/cutClusters.c
--- stamp-0.9.10/ssca2/cutClusters.c	2008-09-09 07:42:07.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/cutClusters.c	2014-12-18 12:23:48.013791448 +0900
@@ -62,6 +62,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -529,7 +530,7 @@
             global_iter = iter;
         }
 
-        TM_BEGIN();
+        TM_BEGIN_ID(7);
         long tmp_cliqueSize = (long)TM_SHARED_READ(global_cliqueSize);
         TM_SHARED_WRITE(global_cliqueSize, (tmp_cliqueSize + cliqueSize));
         TM_END();
@@ -601,7 +602,7 @@
         }
     }
 
-    TM_BEGIN();
+    TM_BEGIN_ID(8);
     long tmp_cutSetIndex = (long)TM_SHARED_READ(global_cutSetIndex);
     TM_SHARED_WRITE(global_cutSetIndex, (tmp_cutSetIndex + cutSetIndex));
     TM_END();
diff -Naur -x .svn stamp-0.9.10/ssca2/Defines.common.mk stamp-0.9.10_Distribute/ssca2/Defines.common.mk
--- stamp-0.9.10/ssca2/Defines.common.mk	2008-09-09 07:42:06.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/Defines.common.mk	2014-12-18 12:39:38.803776599 +0900
@@ -3,8 +3,11 @@
 # Defines.common.mk
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
 
+hostname := $(shell hostname)
+
 PROG := ssca2
 
 SRCS += \
@@ -21,15 +24,59 @@
 	$(LIB)/mt19937ar.c \
 	$(LIB)/random.c \
 	$(LIB)/thread.c \
+	$(LIB)/memory.c
 #
 OBJS := ${SRCS:.c=.o}
 
+CFLAGS += -DUSE_TLH
 #CFLAGS += -DUSE_PARALLEL_DATA_GENERATION
 #CFLAGS += -DWRITE_RESULT_FILES
 CFLAGS += -DENABLE_KERNEL1
 #CFLAGS += -DENABLE_KERNEL2 -DENABLE_KERNEL3
 #CFLAGS += -DENABLE_KERNEL4
 
+RUNPARAMS := -s20 -i1.0 -u1.0 -l3 -p3
+
+.PHONY:	run1 run2 run4 run6 run8 run12 run16 run32 run64 run128 run-16 run-32 run-64
+
+run1:
+	$(PROGRAM) $(RUNPARAMS) -t1
+
+run2:
+	$(PROGRAM) $(RUNPARAMS) -t2
+
+run4:
+	$(PROGRAM) $(RUNPARAMS) -t4
+
+run6:
+	$(PROGRAM) $(RUNPARAMS) -t6
+
+run8:
+	$(PROGRAM) $(RUNPARAMS) -t8
+
+run12:
+	$(PROGRAM) $(RUNPARAMS) -t12
+
+run16:
+	$(PROGRAM) $(RUNPARAMS) -t16
+
+run32:
+	$(PROGRAM) $(RUNPARAMS) -t32
+
+run64:
+	$(PROGRAM) $(RUNPARAMS) -t64
+
+run128:
+	$(PROGRAM) $(RUNPARAMS) -t128
+
+run-16:
+	$(PROGRAM) $(RUNPARAMS) -t-16
+
+run-32:
+	$(PROGRAM) $(RUNPARAMS) -t-32
+
+run-64:
+	$(PROGRAM) $(RUNPARAMS) -t-64
 
 # ==============================================================================
 #
diff -Naur -x .svn stamp-0.9.10/ssca2/genScalData.c stamp-0.9.10_Distribute/ssca2/genScalData.c
--- stamp-0.9.10/ssca2/genScalData.c	2008-09-09 07:42:07.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/genScalData.c	2014-12-18 12:23:59.633661407 +0900
@@ -62,6 +62,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -808,7 +809,7 @@
         long t1 = PRANDOM_GENERATE(stream);
         long t = i + t1 % (TOT_VERTICES - i);
         if (t != i) {
-            TM_BEGIN();
+            TM_BEGIN_ID(0);
             long t2 = (long)TM_SHARED_READ(permV[t]);
             TM_SHARED_WRITE(permV[t], TM_SHARED_READ(permV[i]));
             TM_SHARED_WRITE(permV[i], t2);
@@ -1096,7 +1097,7 @@
         }
     }
 
-    TM_BEGIN();
+    TM_BEGIN_ID(1);
     TM_SHARED_WRITE(global_edgeNum,
                     ((long)TM_SHARED_READ(global_edgeNum) + i_edgePtr));
     TM_END();
@@ -1314,7 +1315,7 @@
         }
     }
 
-    TM_BEGIN();
+    TM_BEGIN_ID(2);
     TM_SHARED_WRITE(global_edgeNum,
                     ((long)TM_SHARED_READ(global_edgeNum) + i_edgePtr));
     TM_END();
@@ -1396,7 +1397,7 @@
         }
     }
 
-    TM_BEGIN();
+    TM_BEGIN_ID(3);
     TM_SHARED_WRITE(global_numStrWtEdges,
                     ((long)TM_SHARED_READ(global_numStrWtEdges) + numStrWtEdges));
     TM_END();
diff -Naur -x .svn stamp-0.9.10/ssca2/getStartLists.c stamp-0.9.10_Distribute/ssca2/getStartLists.c
--- stamp-0.9.10/ssca2/getStartLists.c	2008-09-09 07:42:07.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/getStartLists.c	2014-12-18 12:24:25.608598627 +0900
@@ -62,6 +62,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -119,7 +120,7 @@
         }
     }
 
-    TM_BEGIN();
+    TM_BEGIN_ID(9);
     long tmp_maxWeight = (long)TM_SHARED_READ(global_maxWeight);
     if (maxWeight > tmp_maxWeight) {
         TM_SHARED_WRITE(global_maxWeight, maxWeight);
diff -Naur -x .svn stamp-0.9.10/ssca2/getUserParameters.c stamp-0.9.10_Distribute/ssca2/getUserParameters.c
--- stamp-0.9.10/ssca2/getUserParameters.c	2008-09-09 07:42:08.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/getUserParameters.c	2014-12-18 12:24:34.941601538 +0900
@@ -62,10 +62,15 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
+#if defined(__370__) || defined(_AIX)
+#include <unistd.h>  /* For getopt() */
+#else
 #include <getopt.h>
+#endif
 #include <stdio.h>
 #include <stdlib.h>
 #include "getUserParameters.h"
diff -Naur -x .svn stamp-0.9.10/ssca2/Makefile.hle_intel stamp-0.9.10_Distribute/ssca2/Makefile.hle_intel
--- stamp-0.9.10/ssca2/Makefile.hle_intel	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/Makefile.hle_intel	2014-12-18 12:39:48.885633405 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.hle_intel
+
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/ssca2/Makefile.htm_ibm stamp-0.9.10_Distribute/ssca2/Makefile.htm_ibm
--- stamp-0.9.10/ssca2/Makefile.htm_ibm	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/Makefile.htm_ibm	2014-12-18 12:39:54.952642173 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.htm_ibm
+
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/ssca2/ssca2.c stamp-0.9.10_Distribute/ssca2/ssca2.c
--- stamp-0.9.10/ssca2/ssca2.c	2008-09-09 07:42:08.000000000 +0900
+++ stamp-0.9.10_Distribute/ssca2/ssca2.c	2014-12-18 12:24:41.979630172 +0900
@@ -62,6 +62,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -78,6 +79,10 @@
 #include "timer.h"
 #include "thread.h"
 #include "tm.h"
+#if defined(__bgq__)
+#include <stdint.h>
+#include <spi/include/kernel/location.h>
+#endif
 
 
 MAIN(argc, argv)
@@ -140,6 +145,46 @@
     printf("\nRunning...\n\n");
 
     getUserParameters(argc, (char** const) argv);
+#if defined(__bgq__)
+    if (THREADS < 0) {
+	uint32_t rank;
+	long maxThreads;
+
+	maxThreads = -THREADS;
+	rank = Kernel_GetRank();
+	switch (rank) {
+	case 0:
+	    THREADS = 1;
+	    break;
+#if defined(GLOBAL_LOCK) || defined(HTM_IBM)
+	case 1:
+	    THREADS = 2;
+	    break;
+	case 2:
+	    THREADS = 4;
+	    break;
+	case 3:
+	    THREADS = 8;
+	    break;
+	case 4:
+	    THREADS = 16;
+	    break;
+	case 5:
+	    THREADS = 32;
+	    break;
+	case 6:
+	    THREADS = 64;
+	    break;
+#endif
+	default:
+	    exit(0);
+	    break;
+	}
+	if (maxThreads < THREADS) {
+	    exit(0);
+	}
+    }
+#endif
 
     SIM_GET_NUM_CPU(THREADS);
     TM_STARTUP(THREADS);
diff -Naur -x .svn stamp-0.9.10/vacation/client.c stamp-0.9.10_Distribute/vacation/client.c
--- stamp-0.9.10/vacation/client.c	2008-09-09 07:42:05.000000000 +0900
+++ stamp-0.9.10_Distribute/vacation/client.c	2014-12-18 12:24:53.309647256 +0900
@@ -67,6 +67,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -193,7 +194,7 @@
                     ids[n] = (random_generate(randomPtr) % queryRange) + 1;
                 }
                 bool_t isFound = FALSE;
-                TM_BEGIN();
+                TM_BEGIN_ID(0);
                 for (n = 0; n < numQuery; n++) {
                     long t = types[n];
                     long id = ids[n];
@@ -244,7 +245,7 @@
 
             case ACTION_DELETE_CUSTOMER: {
                 long customerId = random_generate(randomPtr) % queryRange + 1;
-                TM_BEGIN();
+                TM_BEGIN_ID(1);
                 long bill = MANAGER_QUERY_CUSTOMER_BILL(managerPtr, customerId);
                 if (bill >= 0) {
                     MANAGER_DELETE_CUSTOMER(managerPtr, customerId);
@@ -264,7 +265,7 @@
                         prices[n] = ((random_generate(randomPtr) % 5) * 10) + 50;
                     }
                 }
-                TM_BEGIN();
+                TM_BEGIN_ID(2);
                 for (n = 0; n < numUpdate; n++) {
                     long t = types[n];
                     long id = ids[n];
diff -Naur -x .svn stamp-0.9.10/vacation/Defines.common.mk stamp-0.9.10_Distribute/vacation/Defines.common.mk
--- stamp-0.9.10/vacation/Defines.common.mk	2008-09-09 07:42:05.000000000 +0900
+++ stamp-0.9.10_Distribute/vacation/Defines.common.mk	2014-12-18 15:40:26.472658036 +0900
@@ -3,10 +3,19 @@
 # Defines.common.mk
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
 
+hostname := $(shell hostname)
+
+CFLAGS += -DUSE_TLH
 CFLAGS += -DLIST_NO_DUPLICATES
+
+ifeq ($(enable_IBM_optimizations),yes)
+CFLAGS += -DMAP_USE_CONCUREENT_HASHTABLE -DHASHTABLE_SIZE_FIELD -DHASHTABLE_RESIZABLE
+else
 CFLAGS += -DMAP_USE_RBTREE
+endif
 
 PROG := vacation
 
@@ -21,10 +30,101 @@
 	$(LIB)/mt19937ar.c \
 	$(LIB)/random.c \
 	$(LIB)/rbtree.c \
+	$(LIB)/hashtable.c \
+	$(LIB)/conc_hashtable.c \
 	$(LIB)/thread.c \
+	$(LIB)/memory.c
 #
 OBJS := ${SRCS:.c=.o}
 
+#RUNPARAMSLOW := -n2 -q90 -u98 -r16384 -t4096
+RUNPARAMSLOW := -n2 -q90 -u98 -r1048576 -t4194304
+#RUNPARAMSHIGH := -n4 -q60 -u90 -r16384 -t4096
+RUNPARAMSHIGH := -n4 -q60 -u90 -r1048576 -t4194304
+
+.PHONY:	runlow1 runlow2 runlow4 runlow6 runlow8 runlow12 runlow16 runlow32 runlow64 runlow128 runlow-16 runlow-32 runlow-64
+
+runlow1:
+	$(PROGRAM) $(RUNPARAMSLOW) -c1
+
+runlow2:
+	$(PROGRAM) $(RUNPARAMSLOW) -c2
+
+runlow4:
+	$(PROGRAM) $(RUNPARAMSLOW) -c4
+
+runlow6:
+	$(PROGRAM) $(RUNPARAMSLOW) -c6
+
+runlow8:
+	$(PROGRAM) $(RUNPARAMSLOW) -c8
+
+runlow12:
+	$(PROGRAM) $(RUNPARAMSLOW) -c12
+
+runlow16:
+	$(PROGRAM) $(RUNPARAMSLOW) -c16
+
+runlow32:
+	$(PROGRAM) $(RUNPARAMSLOW) -c32
+
+runlow64:
+	$(PROGRAM) $(RUNPARAMSLOW) -c64
+
+runlow128:
+	$(PROGRAM) $(RUNPARAMSLOW) -c128
+
+runlow-16:
+	$(PROGRAM) $(RUNPARAMSLOW) -c-16
+
+runlow-32:
+	$(PROGRAM) $(RUNPARAMSLOW) -c-32
+
+runlow-64:
+	$(PROGRAM) $(RUNPARAMSLOW) -c-64
+
+
+.PHONY:	runhigh1 runhigh2 runhigh4 runhigh6 runhigh8 runhigh12 runhigh16 runhigh32 runhigh64 runhigh128 runhigh-16 runhigh-32 runhigh-64
+
+runhigh1:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c1
+
+runhigh2:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c2
+
+runhigh4:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c4
+
+runhigh6:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c6
+
+runhigh8:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c8
+
+runhigh12:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c12
+
+runhigh16:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c16
+
+runhigh32:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c32
+
+runhigh64:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c64
+
+runhigh128:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c128
+
+runhigh-16:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c-16
+
+runhigh-32:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c-32
+
+runhigh-64:
+	$(PROGRAM) $(RUNPARAMSHIGH) -c-64
+
 
 # ==============================================================================
 #
diff -Naur -x .svn stamp-0.9.10/vacation/Makefile.hle_intel stamp-0.9.10_Distribute/vacation/Makefile.hle_intel
--- stamp-0.9.10/vacation/Makefile.hle_intel	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/vacation/Makefile.hle_intel	2014-12-18 12:40:13.147694698 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.hle_intel
+
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/vacation/Makefile.htm_ibm stamp-0.9.10_Distribute/vacation/Makefile.htm_ibm
--- stamp-0.9.10/vacation/Makefile.htm_ibm	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/vacation/Makefile.htm_ibm	2014-12-18 12:40:17.367723978 +0900
@@ -0,0 +1,18 @@
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.htm_ibm
+
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/vacation/manager.c stamp-0.9.10_Distribute/vacation/manager.c
--- stamp-0.9.10/vacation/manager.c	2008-09-09 07:42:06.000000000 +0900
+++ stamp-0.9.10_Distribute/vacation/manager.c	2014-12-18 12:25:00.458567637 +0900
@@ -68,6 +68,7 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
@@ -109,6 +110,8 @@
 static MAP_T*
 tableAlloc ()
 {
+    /* Odiara memo: This should be TMMAP_ALLOC(),
+       but it is OK for now because the tables are not freed. */
     return MAP_ALLOC(NULL, NULL);
 }
 
@@ -143,12 +146,14 @@
  * -- Note: contents are not deallocated
  * =============================================================================
  */
+/* Glibc doesnt like this function */
+/*
 static void
 tableFree (MAP_T* mapPtr)
 {
     MAP_FREE(mapPtr);
 }
-
+*/
 
 
 /* =============================================================================
@@ -158,10 +163,11 @@
 void
 manager_free (manager_t* managerPtr)
 {
-    tableFree(managerPtr->carTablePtr);
+  // Glibc doesnt like this
+  /*tableFree(managerPtr->carTablePtr);
     tableFree(managerPtr->roomTablePtr);
     tableFree(managerPtr->flightTablePtr);
-    tableFree(managerPtr->customerTablePtr);
+    tableFree(managerPtr->customerTablePtr);*/
 }
 
 
